#include <stdio.h>
#include <stdlib.h>
#include <string.h>


#define	MAXWIDTH	640
#define	MAXHEIGHT	200

int main(int argc, char **argv)
{
	FILE	*infp;
	FILE	*outfp;

	int		pixel_all[MAXWIDTH][MAXHEIGHT];

	int		width_all,height_all;
	int		width,height;
	int		x,y,z,col;
	int		c,i,sft,a0,a1;

	int		xtbl[] = {
		0x00,0x04,0x08,0x0c,0x02,0x06,0x0a,0x0e,
		0x10,0x14,0x18,0x1c,0x12,0x16,0x1a,0x1e,
		0x20,0x24,0x28,0x2c,0x22,0x26,0x2a,0x2e,
		0x30,0x34,0x38,0x3c,0x32,0x36,0x3a,0x3e,
		0x40,0x44,0x48,0x4c,0x42,0x46,0x4a,0x4e,
		0x50,0x54,0x58,0x5c,0x52,0x56,0x5a,0x5e,
		0x60,0x64,0x68,0x6c,0x62,0x66,0x6a,0x6e,
		0x70,0x74,0x78,0x7c,0x72,0x76,0x7a,0x7e,
		0x80,0x84,0x88,0x8c,0x82,0x86,0x8a,0x8e,
		0x90,0x94,0x98,0x9c,0x92,0x96,0x9a,0x9e,
		0xa0,0xa4,0xa8,0xac,0xa2,0xa6,0xaa,0xae,
		0xb0,0xb4,0xb8,0xbc,0xb2,0xb6,0xba,0xbe,
//		0xc0,0xc4,0xc8,0xcc,0xc2,0xc6,0xca,0xce
		0xc0,0xc4,0x08,0x0c,0xc2,0xc6,0x0a,0x0e
		/* c8(=200,201s),ca(=202,203s) ͎gpȂ̂ŁA_~[f[^ɂ */
		/* cc(=204,205s),ce(=206,207s) ̓gpB_~[f[^ɂ */
	};


	if (argc != 3) {
		fprintf(stderr, "Usage: convback infile outfile \n");
		exit(1);
	}

/* open files */

	if ((infp = fopen(argv[1], "rb")) == NULL) {
		perror(argv[1]);
		exit(1);
	}

	if ((outfp = fopen(argv[2], "wb")) == NULL) {
		perror(argv[2]);
		exit(1);
	}

	for (y = 0;y < MAXHEIGHT;y ++) {
		for (x = 0;x < MAXWIDTH;x ++) {
			pixel_all[x][y] = 0x08;
		}
	}

	width_all  = MAXWIDTH;
	height_all = MAXHEIGHT;

	width  = width_all;
	height = height_all;

/* GRB */
	for (col = 0x01;col < 0x08;col *= 2) {

		for (y = 0;y < height;y ++) {
			for (x = 0;x < width;x += 8) {
				c = fgetc(infp);
				sft = 0x80;
				for (i = 0;i < 8;i ++) {
					if ( (c & sft) != 0) {
						pixel_all[x+i][y] |= col;
					}
					sft /= 2;
				}
			}
		}

		for (i = 0;i < 384;i ++) {
			fgetc(infp);
		}

	}

/* F炷 */
	for (y = 0;y < MAXHEIGHT;y ++) {
		for (x = 0;x < MAXWIDTH;x ++) {
			switch (pixel_all[x][y]) {
				case 0x08: pixel_all[x][y] = 0x00; break; /*      00 */
				case 0x09: pixel_all[x][y] = 0x00; break; /*  00 */
				case 0x0a: pixel_all[x][y] = 0x01; break; /*      01 */
				case 0x0b: pixel_all[x][y] = 0x01; break; /*  01 */
				case 0x0c: pixel_all[x][y] = 0x00; break; /* ΁ 00 */
				case 0x0d: pixel_all[x][y] = 0x02; break; /*  10 */
				case 0x0e: pixel_all[x][y] = 0x02; break; /*      10 */
				case 0x0f: pixel_all[x][y] = 0x03; break; /*      11 */
				default: break;
			}
		}
	}

/* P6SRVRAMɍ킹ďo */

/* ʁi0000-19ffj */

	for (z = 0;z < 104;z ++) {
		for (x = 512;x < 640;x += 8) {
			for (y = xtbl[z];y < xtbl[z]+2;y ++) {
				a0 =
					( (pixel_all[x+0][y] & 0x01) == 0x00 ? 0x00 : 0x80) +
					( (pixel_all[x+1][y] & 0x01) == 0x00 ? 0x00 : 0x40) +
					( (pixel_all[x+2][y] & 0x01) == 0x00 ? 0x00 : 0x20) +
					( (pixel_all[x+3][y] & 0x01) == 0x00 ? 0x00 : 0x10) +
					( (pixel_all[x+4][y] & 0x01) == 0x00 ? 0x00 : 0x08) +
					( (pixel_all[x+5][y] & 0x01) == 0x00 ? 0x00 : 0x04) +
					( (pixel_all[x+6][y] & 0x01) == 0x00 ? 0x00 : 0x02) +
					( (pixel_all[x+7][y] & 0x01) == 0x00 ? 0x00 : 0x01);
				fputc(a0, outfp);

				a1 =
					( (pixel_all[x+0][y] & 0x02) == 0x00 ? 0x00 : 0x80) +
					( (pixel_all[x+1][y] & 0x02) == 0x00 ? 0x00 : 0x40) +
					( (pixel_all[x+2][y] & 0x02) == 0x00 ? 0x00 : 0x20) +
					( (pixel_all[x+3][y] & 0x02) == 0x00 ? 0x00 : 0x10) +
					( (pixel_all[x+4][y] & 0x02) == 0x00 ? 0x00 : 0x08) +
					( (pixel_all[x+5][y] & 0x02) == 0x00 ? 0x00 : 0x04) +
					( (pixel_all[x+6][y] & 0x02) == 0x00 ? 0x00 : 0x02) +
					( (pixel_all[x+7][y] & 0x02) == 0x00 ? 0x00 : 0x01);
				fputc(a1, outfp);
			}
		}
	}

/* Eʁi1a00-7fffj */
/* 200`203s̓_~[𑗐M */

	for (z = 0;z < 100;z ++) {
		for (x = 0;x < 512;x += 8) {
			for (y = z*2;y < z*2+2;y ++) {
				a0 =
					( (pixel_all[x+0][y] & 0x01) == 0x00 ? 0x00 : 0x80) +
					( (pixel_all[x+1][y] & 0x01) == 0x00 ? 0x00 : 0x40) +
					( (pixel_all[x+2][y] & 0x01) == 0x00 ? 0x00 : 0x20) +
					( (pixel_all[x+3][y] & 0x01) == 0x00 ? 0x00 : 0x10) +
					( (pixel_all[x+4][y] & 0x01) == 0x00 ? 0x00 : 0x08) +
					( (pixel_all[x+5][y] & 0x01) == 0x00 ? 0x00 : 0x04) +
					( (pixel_all[x+6][y] & 0x01) == 0x00 ? 0x00 : 0x02) +
					( (pixel_all[x+7][y] & 0x01) == 0x00 ? 0x00 : 0x01);
				fputc(a0, outfp);

				a1 =
					( (pixel_all[x+0][y] & 0x02) == 0x00 ? 0x00 : 0x80) +
					( (pixel_all[x+1][y] & 0x02) == 0x00 ? 0x00 : 0x40) +
					( (pixel_all[x+2][y] & 0x02) == 0x00 ? 0x00 : 0x20) +
					( (pixel_all[x+3][y] & 0x02) == 0x00 ? 0x00 : 0x10) +
					( (pixel_all[x+4][y] & 0x02) == 0x00 ? 0x00 : 0x08) +
					( (pixel_all[x+5][y] & 0x02) == 0x00 ? 0x00 : 0x04) +
					( (pixel_all[x+6][y] & 0x02) == 0x00 ? 0x00 : 0x02) +
					( (pixel_all[x+7][y] & 0x02) == 0x00 ? 0x00 : 0x01);
				fputc(a1, outfp);
			}
		}
	}

	for (z = 100;z < 102;z ++) {
		for (x = 0;x < 512;x += 8) {
			for (y = z*2;y < z*2+2;y ++) {
				fputc(0xff, outfp);
				fputc(0xff, outfp);
			}
		}
	}


	fclose(outfp);
	fclose(infp);

	return(0);
}

