#include <stdio.h>
#include <stdlib.h>
#include <string.h>


#define	MAXWIDTH	56
#define	MAXHEIGHT	64

int main(int argc, char **argv)
{
	FILE	*infp;
	FILE	*outfp;

	int		pixel[56][16];
	int		pixel_all[MAXWIDTH][MAXHEIGHT];

	int		width_all,height_all;
	int		width,height;
	int		xa,ya,za,wa,ww;
	int		x,y,col;
	int		c,i,sft,a0,a1;
	int		offset;

	if (argc != 4) {
		fprintf(stderr, "Usage: convpict infile outfile offset\n");
		exit(1);
	}

/* open files */

	if ((infp = fopen(argv[1], "rb")) == NULL) {
		perror(argv[1]);
		exit(1);
	}

	if ((outfp = fopen(argv[2], "wb")) == NULL) {
		perror(argv[2]);
		exit(1);
	}

	offset = atoi(argv[3]);
	fseek(infp,(long)offset,SEEK_SET);

	for (y = 0;y < MAXHEIGHT;y ++) {
		for (x = 0;x < MAXWIDTH;x ++) {
			pixel_all[x][y] = 0x07;
		}
	}

	width  = 56;
	height = 16;

	for (ya = 0;ya < 4;ya ++) {
		for (xa = 0;xa < 1;xa ++) {

			for (y = 0;y < height;y ++) {
				for (x = 0;x < width;x ++) {
					pixel[x][y] = 0x08;
				}
			}

/* GRB */
			for (col = 0x01;col < 0x08;col *= 2) {

				for (y = 0;y < height;y ++) {
					for (x = 0;x < width;x += 8) {
						c = fgetc(infp);
						sft = 0x80;
						for (i = 0;i < 8;i ++) {
							if ( (c & sft) != 0) {
								pixel[x+i][y] |= col;
							}
							sft /= 2;
						}
					}
				}

			}

			for (y = 0;y < height;y ++) {
				for (x = 0;x < width;x ++) {
					pixel_all[xa*width +x][ya*height +y] = pixel[x][y];
				}
			}

		}

	}

/* F炷 */
	for (y = 0;y < MAXHEIGHT;y ++) {
		for (x = 0;x < MAXWIDTH;x ++) {
			switch (pixel_all[x][y]) {
				case 0x08: pixel_all[x][y] = 0x00; break; /*      000 */
				case 0x09: pixel_all[x][y] = 0x00; break; /*  000 */
				case 0x0a: pixel_all[x][y] = 0x02; break; /*      010 */
				case 0x0b: pixel_all[x][y] = 0x00; break; /*  000 */
				case 0x0c: pixel_all[x][y] = 0x00; break; /* ΁ 000 */
				case 0x0d: pixel_all[x][y] = 0x04; break; /*  100 */
				case 0x0e: pixel_all[x][y] = 0x04; break; /*      100 */
				case 0x0f: pixel_all[x][y] = 0x06; break; /*      110 */
				default: break;
			}
		}
	}


	for (ya = 0;ya < 4;ya ++) {
		for (xa = 0;xa < 1;xa ++) {

/* B */
			for (col = 0x01;col < 0x02;col *= 2) {
				for (y = 0;y < height;y ++) {
					for (x = 0;x < width;x += 8) {
						fputc(0xff, outfp);
					}
				}
			}
/* GR */
			for (col = 0x02;col < 0x08;col *= 2) {
				for (y = 0;y < height;y ++) {
					for (x = 0;x < width;x += 8) {

						a0 =
							( (pixel_all[xa*width+x+0][ya*height+y] & col) == 0x00 ? 0x00 : 0x80) +
							( (pixel_all[xa*width+x+1][ya*height+y] & col) == 0x00 ? 0x00 : 0x40) +
							( (pixel_all[xa*width+x+2][ya*height+y] & col) == 0x00 ? 0x00 : 0x20) +
							( (pixel_all[xa*width+x+3][ya*height+y] & col) == 0x00 ? 0x00 : 0x10) +
							( (pixel_all[xa*width+x+4][ya*height+y] & col) == 0x00 ? 0x00 : 0x08) +
							( (pixel_all[xa*width+x+5][ya*height+y] & col) == 0x00 ? 0x00 : 0x04) +
							( (pixel_all[xa*width+x+6][ya*height+y] & col) == 0x00 ? 0x00 : 0x02) +
							( (pixel_all[xa*width+x+7][ya*height+y] & col) == 0x00 ? 0x00 : 0x01);
						fputc(a0, outfp);

					}
				}
			}

		}

	}

	fclose(outfp);
	fclose(infp);

	return(0);
}

